#COMPILE EXE
#DIM ALL
'#INCLUDE "myAddMachineAPI.inc"
#INCLUDE "win32api.inc"
'#INCLUDE "debug.inc"

$ver = "1.21"

%IDC_Editbox = 100
%IDC_Listbox = 200
%IDC_Total   = 300
%IDC_PrgHelp = 401
%IDC_Reset   = 402
%IDC_Print   = 403
%IDC_Copy    = 404

GLOBAL hMain, gOrigEditbox AS LONG
GLOBAL hEditbox, dlgWidth AS LONG
GLOBAL numItems, arrowKey AS LONG
GLOBAL total AS DOUBLE
GLOBAL sEdit AS STRING

FUNCTION PBMAIN()
   LOCAL nStyle AS LONG
   DIALOG FONT "arial", 10
   nStyle = %WS_CAPTION OR %WS_POPUP OR %DS_MODALFRAME OR %WS_SYSMENU OR %WS_MINIMIZEBOX
   dlgWidth = 260
   DIALOG NEW PIXELS, 0, "Adding Machine " + $ver, , , dlgWidth, 370, nStyle TO hMain
   CONTROL ADD TEXTBOX, hMain, %IDC_Editbox, "", 40, 10, 45, 20, %WS_TABSTOP, %WS_EX_CLIENTEDGE
   nStyle = %WS_VSCROLL OR %LBS_USETABSTOPS OR %LBS_DISABLENOSCROLL
   CONTROL ADD LISTBOX, hMain, %IDC_Listbox, , 40, 32, 62, 280, nStyle, %WS_EX_CLIENTEDGE
   CONTROL ADD LABEL, hMain, %IDC_Total, "", 40, 310, 130, 20, %SS_RIGHT
   CONTROL ADD BUTTON, hMain, %IDC_PrgHelp, "&Help", 10, 340, 55, 25
   CONTROL ADD BUTTON, hMain, %IDC_Reset, "&Reset", 100, 340, 55, 25
   CONTROL ADD BUTTON, hMain, %IDC_Print, "&Print", 155, 340, 55, 25
   DIALOG SHOW MODAL hMain CALL mainProc
END FUNCTION

CALLBACK FUNCTION mainProc()
   LOCAL k, m, n, x0, b, wi, fontSize, hFont, hOrigFont, hAccel, hdc AS LONG
   LOCAL s, sList AS STRING
   local dwd as dword
   local pt as pointapi
   local sz AS SIZEL
   SELECT CASE CBMSG
      CASE %WM_INITDIALOG
         fontSize = 10
         FONT NEW "Courier New", fontSize TO hFont
         CONTROL SET FONT CB.HNDL, %IDC_Listbox, hFont
         CONTROL SET FONT CB.HNDL, %IDC_Editbox, hFont
         CONTROL SET FONT CB.HNDL, %IDC_Total, hFont
         CONTROL HANDLE CBHNDL, %IDC_Editbox TO hEditbox
         s = string$(16, "0")
         hdc = GetDC(hEditbox)
         SetMapMode (hdc, %MM_TEXT)
         'hFont = makeFont(hdc, "Courier", fontSize)
         hFont = SendMessage (hEditbox, %WM_GETFONT, 0, 0)
         SelectObject(hdc, hFont)
         'SetMapMode (hdc, %MM_TEXT)
         GetTextExtentPoint32 hdc, byval strptr(s), byval len(s), pt
         wi = pt.x + 8: b = GetSystemMetrics(%SM_CXVSCROLL)
         x0 = (dlgWidth - wi - b)/2
         control set size cb.hndl, %IDC_Editbox, wi, 20
         control set size cb.hndl, %IDC_Listbox, wi + b, 280
         control set size cb.hndl, %IDC_Total, wi, 20
         control set loc cb.hndl, %IDC_Editbox, x0, 10
         control set loc cb.hndl, %IDC_Listbox, x0, 32
         control set loc cb.hndl, %IDC_Total, x0, 310
         
         REDIM ac(1 TO 1) AS ACCELAPI
         ac(1).fvirt = %FVIRTKEY OR %FCONTROL
         ac(1).key = %VK_C
         ac(1).cmd =  %IDC_Copy
         ACCEL ATTACH CBHNDL, ac() TO hAccel

         'setup subclass of textbox %IDC_Editbox to capture Return
         gOrigEditbox = SetWindowLong(hEditbox, %GWL_WNDPROC, CODEPTR(subClassEditbox))
      CASE %WM_COMMAND
         SELECT CASE CBCTL
            CASE %IDC_Listbox
               IF CBCTLMSG = %LBN_SELCHANGE THEN
                  CONTROL SET FOCUS CBHNDL, %IDC_Editbox  
               END IF
            CASE %IDC_Editbox
               IF CBCTLMSG = %EN_UPDATE THEN
                  SendMessage hEditbox, %EM_GetSel, VARPTR(m), 0
                  CONTROL GET TEXT CBHNDL, CBCTL TO s
                  n = ASC(MID$(s, m, 1))
                  IF n < 0 THEN EXIT FUNCTION
                  IF n >= 48 AND n <= 57 THEN 'numeral 0-9
                     sEdit = s
                  ELSEIF n = 46 AND (PARSECOUNT(s, ".") <= 2) THEN 
                     sEdit = s
                     msgbox sEdit   
                  ELSEIF (n = 43 OR n = 45) AND m = 1 THEN '+ or -
                     sEdit = s
                  ELSE
                     CONTROL SET TEXT CBHNDL, CBCTL, sEdit
                     SendMessage hEditbox, %EM_SetSel, m-1, m-1
                  END IF
               END IF
            CASE %IDC_Reset
               numItems = 0: total = 0
               LISTBOX RESET CBHNDL, %IDC_Listbox
               CONTROL SET TEXT CBHNDL, %IDC_Total, ""
               CONTROL SET FOCUS CBHNDL, %IDC_Editbox
            CASE %IDC_Print
               XPRINT ATTACH CHOOSE
               XPRINT FONT "Times New Roman", 10
               XPRINT SPACE$(20) + "List from My Adding Machine"
               XPRINT: XPRINT
               FOR k = 1 TO numItems
                  LISTBOX GET TEXT CBHNDL, %IDC_Listbox, k TO s
                  n = INSTR(s, ".")
                  IF n = 0 THEN n = LEN(s) + 1: s = s + "."
                  s = LEFT$(s + "00", n + 2)
                  XPRINT SPACE$(40 - LEN(s)) + s
               NEXT k
               XPRINT
               s = FORMAT$(total, "#.00")
               XPRINT SPACE$(40 - LEN(s)) + s + " Total"                                             
               XPRINT CLOSE
               CONTROL SET FOCUS CB.HNDL, %IDC_Editbox       
            CASE %IDC_Copy
               FOR k = 1 TO numItems
                  LISTBOX GET TEXT CB.HNDL, %IDC_Listbox, k TO s
                  sList = sList + SPACE$(15 - LEN(s)) + s + $CRLF
               NEXT k
               sList = sList + $CRLF
               s = FORMAT$(total, "#.00")
               sList = sList + SPACE$(16 - LEN(s)) + s + " Total"
               CLIPBOARD SET TEXT sList         
            CASE %IDC_PrgHelp
               showHelp   
         END SELECT
      CASE %WM_SYSCOMMAND
      CASE %WM_DESTROY
   END SELECT
END FUNCTION

FUNCTION makeFont(hdc AS LONG, fontName AS STRING, fontSize AS LONG) AS DWORD
   LOCAL cyPixels, charHt AS DWORD
   cyPixels  = GetDeviceCaps(hDC, %LOGPIXELSY)
   charHt = (fontSize * CyPixels) \ 72
   FUNCTION = CreateFont(-charHt, 0, 0, 0, 0, 0, 0, 0, _
              %ANSI_CHARSET, %OUT_TT_PRECIS, %CLIP_DEFAULT_PRECIS, _
              %DEFAULT_QUALITY, %FF_DONTCARE, BYCOPY fontName)
END FUNCTION

FUNCTION subClassEditbox(BYVAL hWnd&, BYVAL wMsg&, BYVAL wParm&, BYVAL lParm&) AS LONG
   LOCAL k, m, n, showTotal AS LONG, v AS DOUBLE
   LOCAL s, neg AS STRING, sz AS ASCIIZ * 32
   SELECT CASE wMsg&
      CASE %WM_KEYUP
         showTotal = 0
         SELECT CASE wParm&
            CASE %VK_RETURN, %VK_ADD, %VK_SUBTRACT, %VK_OEM_PLUS, %VK_OEM_MINUS
               CONTROL GET TEXT hMain, %IDC_Editbox TO s: v = VAL(s)
               IF v THEN
                  IF wParm& = %VK_SUBTRACT OR wParm& = %VK_OEM_MINUS THEN v = -ABS(v)
                  s = FORMAT$(v, "0.00")
                  s = SPACE$(16 - LEN(s)) + s: INCR numItems
                  LISTBOX ADD hMain, %IDC_Listbox, s
                  CONTROL SET TEXT hMain, %IDC_Editbox, ""
                  LISTBOX SELECT hMain, %IDC_Listbox, numItems
                  total = total + VAL(FORMAT$(v, "0.00")): showTotal = 1
               END IF
            CASE %VK_INSERT
               IF (GetKeyState(%VK_CONTROL) AND &H8000) THEN 'ctrl key down
                  s = sEdit: v = VAL(s)
                  IF v THEN
                     s = FORMAT$(v, "0.00")
                     s = SPACE$(16 - LEN(s)) + s: INCR numItems
                     LISTBOX GET SELECT hMain, %IDC_Listbox TO n
                     LISTBOX INSERT hMain, %IDC_Listbox, n, s
                     LISTBOX SELECT hMain, %IDC_Listbox, n
                     CONTROL SET TEXT hMain, %IDC_Editbox, ""
                     total = total + VAL(FORMAT$(v, "0.00")): showTotal = 1
                  END IF
               END IF    
            CASE %VK_DELETE 'delete or edit
               IF (GetKeyState(%VK_CONTROL) AND &H8000) THEN 'ctrl key down
                  LISTBOX GET TEXT hMain, %IDC_Listbox TO s: v = VAL(s)
                  IF v THEN
                     DECR numItems: numItems = MAX(0, numItems)
                     LISTBOX GET SELECT hMain, %IDC_Listbox TO n
                     LISTBOX DELETE hMain, %IDC_Listbox, n
                     LISTBOX SELECT hMain, %IDC_Listbox, MIN(n, numItems)
                     sEdit = TRIM$(MID$(s, 2))
                     CONTROL SET TEXT hMain, %IDC_Editbox, sEdit                               
                     'SendMessage hEditbox, %EM_SETSEL, 0, -1
                     total = total - VAL(FORMAT$(v, "0.00")): showTotal = 1
                  END IF
               END IF 
            CASE %VK_UP
               LISTBOX GET SELECT hMain, %IDC_Listbox TO n
               LISTBOX SELECT hMain, %IDC_Listbox, MAX(n - 1, 1)                                   
            CASE %VK_DOWN
               LISTBOX GET SELECT hMain, %IDC_Listbox TO n
               LISTBOX SELECT hMain, %IDC_Listbox, MIN(n + 1, numItems)
            CASE %VK_ESCAPE 'clear entry
               CONTROL SET TEXT hMain, %IDC_Editbox, ""
               CONTROL SET FOCUS hMain, %IDC_Editbox
            CASE %VK_F1 'help
               showHelp                                          
            CASE %VK_F2 'duplicate selected entry
               LISTBOX GET TEXT hMain, %IDC_Listbox TO s
               sEdit = MID$(s, 2)
               CONTROL SET TEXT hMain, %IDC_Editbox, sEdit
            CASE %VK_5
               IF (GetKeyState(%VK_SHIFT) AND &H8000) THEN 'shift key down
                  CONTROL GET TEXT hMain, %IDC_Editbox TO s
                  v = VAL(s)/100*total: s = FORMAT$(v, "0.00")
                  s = SPACE$(16 - LEN(s)) + s: INCR numItems
                  LISTBOX ADD hMain, %IDC_Listbox, s
                  CONTROL SET TEXT hMain, %IDC_Editbox, ""
                  LISTBOX SELECT hMain, %IDC_Listbox, numItems
                  total = total + VAL(FORMAT$(v, "0.00")): showTotal = 1
               END IF
         END SELECT
         IF showTotal THEN
            s = FORMAT$(total, "0.00")
            CONTROL SET TEXT hMain, %IDC_Total, s
         END IF 
   END SELECT
   'pass the message on to the original window procedure
   FUNCTION = CallWindowProc(gOrigEditbox, hWnd&, wMsg&, wParm&, lParm&)
END FUNCTION

SUB showHelp
   LOCAL hHelp, nStyle, count AS LONG, ti, s AS STRING
   ti = "Adding Machine - Ver " + $ver
   s = "To add entry: [ADD or ENTER]" + $CRLF _
     + "To subtract entry: [SUB] or add [-number]" + $CRLF _ 
     + "To clear entry: [ESC]" + $CRLF _ 
     + "To duplicate, retrieve selected item: [F2]" + $CRLF _
     + "To add entry at selected item: [CTRL+INS]" + $CRLF _
     + "To delete selected item: [CTRL+DEL]" + $CRLF _
     + "To edit or move selected item: [CTRL+DEL]...[CTRL+INS]" + $CRLF _
     + "To add percent of current total: [%]" + $CRLF _
     + "To copy list to clipboard: [CTRL+C]"
   nStyle = %WS_CAPTION OR %WS_POPUP OR %DS_MODALFRAME OR %WS_SYSMENU
   DIALOG NEW hMain, ti, 20, 70, 200, 90, nStyle TO hHelp
   CONTROL ADD LABEL, hHelp, -1, s, 5, 5, 190, 80
   DIALOG SHOW MODAL hHelp CALL showHelpProc
END SUB

CALLBACK FUNCTION showHelpProc()
   IF CBMSG = %WM_COMMAND AND CBCTL = %IDCANCEL THEN DIALOG END CBHNDL
END FUNCTION

